Network Load Balancing

You can use Network Load Balancing (NLB) in Windows Server® 2008 to enhance the scalability and availability of server applications. NLB can also help you scale your server's performance to keep up with the increasing demands of your Internet-based clients. This topic includes information about:

Overview of Network Load Balancing

Checklist: Getting Started with Network Load Balancing

Installing Network Load Balancing

Creating Network Load Balancing Clusters

Managing Network Load Balancing Clusters

Setting Network Load Balancing Parameters

Controlling Hosts on Network Load Balancing Clusters

Removing Network Load Balancing

Troubleshooting Network Load Balancing Clusters

Resources for Network Load Balancing

User Interface: Network Load Balancing Manager


Overview of Network Load Balancing

The Network Load Balancing (NLB) feature in Windows Server 2008 enhances the availability and scalability of Internet server applications such as those used on Web, FTP, firewall, proxy, virtual private network (VPN), and other mission-critical servers. A single computer running Windows Server 2008 provides a limited level of server reliability and scalable performance. However, by combining the resources of two or more computers running one of the products in Windows Server 2008 into a single virtual cluster, NLB can deliver the reliability and performance that Web servers and other mission-critical servers need.

Network Load Balancing cluster with four hosts

The diagram above depicts two connected Network Load Balancing clusters. The first cluster consists of two hosts and the second cluster consists of four hosts. This is one example of how you can use NLB.

Each host runs a separate copy of the desired server applications (such as applications for Web, FTP, and Telnet servers). NLB distributes incoming client requests across the hosts in the cluster. The load weight to be handled by each host can be configured as necessary. You can also add hosts dynamically to the cluster to handle increased load. In addition, NLB can direct all traffic to a designated single host, which is called the default host.

NLB allows all of the computers in the cluster to be addressed by the same set of cluster IP addresses, and it maintains a set of unique, dedicated IP addresses for each host. For load-balanced applications, when a host fails or goes offline, the load is automatically redistributed among the computers that are still operating. When a computer fails or goes offline unexpectedly, active connections to the failed or offline server are lost. However, if you bring a host down intentionally, you can use the drainstop command to service all active connections prior to bringing the computer offline. In any case, when it is ready, the offline computer can transparently rejoin the cluster and regain its share of the workload, which allows the other computers in the cluster to handle less traffic.

The hosts in an NLB cluster exchange heartbeat messages to maintain consistent data about the cluster’s membership. By default, when a host fails to send heartbeat messages within five seconds, it has failed. When a host has failed, the remaining hosts in the cluster converge and do the following:

  • Establish which hosts are still active members of the cluster.

  • Elect the host with the highest priority as the new default host.

  • Ensure that all new client requests are handled by the surviving hosts.

During a convergence, the surviving hosts look for consistent heartbeats. If the host that failed to send heartbeats begins to provides heartbeats consistently, it rejoins the cluster in the course of the convergence. When a new host attempts to join the cluster, it sends heartbeat messages that also trigger a convergence. After all cluster hosts agree on the current cluster membership, the client load is redistributed to the remaining hosts, and the convergence completes.

Convergence generally takes only a few seconds, so interruption in client service by the cluster is minimal. During convergence, hosts that are still active continue handling client requests without affecting existing connections. Convergence ends when all hosts report a consistent view of the cluster membership and distribution map for several heartbeat periods.

What is new in NLB?

NLB includes the following improvements for Windows Server 2008:

  • Support for IPv6. NLB fully supports IPv6 for all communication. All NLB components support IPv6 addresses, and the addresses can be configured as the primary cluster IP address, the dedicated IP addresses, and the virtual IP addresses. In addition, IPv6 can be load balanced as native IPv6 and in the IPv6 over IPv4 modes.

  • Support for NDIS 6.0. The NLB driver uses the NDIS 6.0 lightweight filter model. NDIS 6.0 retains backward compatibility with earlier NDIS versions. The design of NDIS 6.0 includes enhanced driver performance and scalability and a simplified NDIS driver model.

  • WMI enhancements. The MicrosoftNLB namespace adds multiple dedicated IP address support for IPv6, which include:

    • Classes in the MicrosoftNLB namespace support IPv6 addresses (in addition to IPv4 addresses).

    • The MicrosoftNLB_NodeSetting class supports multiple dedicated IP addresses by specifying them in DedicatedIPAddresses and DedicatedNetMasks.

  • Improved denial of service (DoS) attack and timer starvation protection. Using a callback interface, NLB can detect and notify applications during an attack or when a node is under excessive load. ISA Server uses this functionality in scenarios where the cluster node is overloaded or is being attacked..

  • Support for multiple dedicated IP addresses per node. NLB fully supports defining more than one dedicated IP address per node. Previously only one dedicated IP address per node was supported. This functionality is used by ISA Server to manage each NLB node for scenarios where clients consist of both IPv4 and IPv6 traffic.

  • Support for rolling upgrades. NLB supports rolling upgrades from Windows Server 2003 to Windows Server 2008. For deployment information for NLB, including information on rolling upgrades, see http://go.microsoft.com/fwlink/?LinkId=87253.

  • Consolidated management through Network Load Balancing Manager. Using the Network Connections tool is no longer required to configure NLB clusters—NLB cluster configuration is performed solely through NLB Manager in Windows Server 2008. This minimizes possible NLB configuration issues that are caused by inconsistencies in settings across cluster hosts.

NLB configuration

NLB runs as a Windows networking driver. Its operations are transparent to the TCP/IP networking stack.

Relationship between NLB and other components

The diagram above shows the relationship between NLB and other software components in a typical configuration of a NLB host.

Features in Network Load Balancing

NLB includes the following features:

Scalability

Scalability is the measure of how well a computer, service, or application can grow to meet increasing performance demands. For NLB clusters, scalability is the ability to incrementally add one or more systems to an existing cluster when the overall load of the cluster exceeds its capabilities. The following list details the scalability features of NLB:

  • Balances load requests across the NLB cluster for individual TCP/IP services

  • Supports up to 32 computers in a single cluster

  • Balances multiple server load requests (from either the same client or from several clients) across multiple hosts in the cluster

  • Supports the ability to add hosts to the NLB cluster as the load goes up, without bringing the cluster down

  • Supports the ability to remove hosts from the cluster when the load goes down

  • Enables high performance and low overhead through fully pipelined implementation. Pipelining allows requests to be sent to the NLB cluster without waiting for response to the previously sent one

High-availability

A highly available system reliably provides an acceptable level of service with minimal downtime. NLB includes built-in features that can provide high availability by automatically:

  • Detecting and recovering from a cluster host that fails or goes offline.

  • Balancing the network load when hosts are added or removed.

  • Recovering and redistributing the workload within ten seconds.

Manageability

NLB provides the following manageability features:

  • You can manage and configure multiple NLB clusters and the cluster hosts from a single computer by using NLB Manager.

  • You can specify the load balancing behavior for a single IP port or group of ports by using port management rules.

  • You can define different port rules for each Web site. If you use the same set of load-balanced servers for multiple applications or Web sites, port rules are based on the destination virtual IP address (using virtual clusters).

  • You can direct all client requests to a single host by using optional, single-host rules. NLB routes client requests to a particular host that is running specific applications.

  • You can block undesired network access to certain IP ports.

  • You can enable Internet Group Management Protocol (IGMP) support on the cluster hosts to control switch flooding (when operating in multicast mode).

  • You can remotely start, stop, and control NLB actions from any networked computer that is running Windows by using shell commands or scripts.

  • You can view the Windows event log to check NLB events. NLB logs all actions and cluster changes in the event log.

Ease-of-use

NLB provides many features that make it convenient to use:

  • NLB is installed as a standard Windows networking driver component.

  • NLB requires no hardware changes to enable and run.

  • NLB Manager enables you to create new NLB clusters.

  • NLB Manager enables you to configure and manage multiple clusters and all of the cluster's hosts from a single remote or local computer.

  • NLB lets clients access the cluster by using a single, logical Internet name and virtual IP address—known as the cluster IP address (it retains individual names for each computer). NLB allows multiple virtual IP addresses for multihomed servers.

    Note

    In the case of virtual clusters, the servers do not need to be multihomed to have multiple virtual IP addresses.

  • NLB can be bound to multiple network adapters, which allows you to configure multiple independent clusters on each host. Support for multiple network adapters differs from virtual clusters in that virtual clusters allow you to configure multiple clusters on a single network adapter.

  • You do not have to modify server applications to run in an NLB cluster.

  • If a cluster host fails and then is subsequently brought back online, NLB can be configured to automatically add that host to the cluster. The added host will then be able to start handling new server requests from clients.

  • You can take computers offline for preventive maintenance without disturbing cluster operations on the other hosts.

Additional references

Installing Network Load Balancing

Checklist: Getting Started with Network Load Balancing

Creating Network Load Balancing Clusters

Managing Network Load Balancing Clusters

Setting Network Load Balancing Parameters

Controlling Hosts on Network Load Balancing Clusters

Troubleshooting Network Load Balancing Clusters

User Interface: Network Load Balancing Manager


Checklist: Getting Started with Network Load Balancing

Use the following checklist to get started with Network Load Balancing (NLB).

Task | References
Install NLB. | Installing Network Load Balancing
Use NLB Manager to create NLB clusters. | Create a New Network Load Balancing Cluster
Configure host parameters, cluster parameters, and port rules. | Create a New Network Load Balancing Cluster Network Load Balancing Manager Properties Setting Network Load Balancing Parameters
Add hosts to the NLB cluster. | Add a Host to the Network Load Balancing Cluster
Maintain the proper control of hosts on your NLB clusters. | Stop or Start Handling Network Load Balancing Cluster Traffic Suspend or Resume Network Load Balancing Disable or Enable All Network Load Balancing Traffic Handling for Specific Ports Disable New Network Load Balancing Traffic Handling for Specific Ports

Additional considerations

  • When you are using NLB Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

Additional references

  • Overview of Network Load Balancing

  • Troubleshooting Network Load Balancing Clusters

  • Resources for Network Load Balancing


Installing Network Load Balancing

To use Network Load Balancing (NLB), a computer must have only TCP/IP on the adapter on which NLB is installed. Do not add any other protocols (for example, IPX) to this adapter. NLB can load balance any application or service that uses TCP/IP as its network protocol and is associated with a specific Transmission Control Protocol (TCP) or User Datagram Protocol (UDP) port.

To install and configure NLB, you must use an account that is listed in the Administrators group on each host. If you are not using an account in the Administrators group as you install and configure each host, you will be prompted to provide the logon credentials for such an account. To set up an account that NLB Manager will use by default: in NLB Manager, expand the Options menu, and then click Credentials. We recommend that this account not be used for any other purpose.

To open the Add Features Wizard and install NLB

  1. Click Start, click Administrative Tools, and then click Server Manager.

  2. In the Features Summary area of the Server Manager main window, click Add Features.

    —or—

    In the Customize this server area of the Initial Configuration Tasks window, click Add Features.

  3. In the Add Features Wizard, select the Network Load Balancing check box.

  4. Click Install.

  5. Alternatively, you can install NLB by typing the following command:

    servermanagercmd.exe -install nlb

  6. After NLB is installed, you can configure an NLB cluster by using Network Load Balancing (NLB) Manager.

    To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open Network Load Balancing Manager by typing Nlbmgr at a command prompt.

Additional references

Overview of Network Load Balancing

Creating Network Load Balancing Clusters

Removing Network Load Balancing


Creating Network Load Balancing Clusters

To learn how to use Network Load Balancing (NLB) Manager to create NLB clusters, see the following topics:

Create a New Network Load Balancing Cluster

Add a Host to the Network Load Balancing Cluster


Create a New Network Load Balancing Cluster

To configure the Network Load Balancing (NLB) cluster, you must configure three types of the parameters:

  • Host parameters, which are specific to each host in a NLB cluster.

  • Cluster parameters, which apply to an NLB cluster as a whole.

  • Port rules, which control how the cluster functions. By default, a port rule equally balances all TCP/IP traffic across all servers. Some applications may require different or additional port rules to operate correctly. For example, when using NLB in a Terminal Services environment, you will need to modify these default rules.

When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

To create a new NLB cluster

  1. To open Network Load Balancing Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open Network Load Balancing Manager by typing Nlbmgr at a command prompt.

  2. Right-click Network Load Balancing Clusters, and then click New Cluster.

  3. To connect to the host that is to be a part of the new cluster, in the Host text box, type the name of the host, and then click Connect.

  4. Select the interface that you want to use with the cluster, and then click Next. (The interface hosts the virtual IP address and receives the client traffic to load balance.)

  5. In Host Parameters, select a value in Priority (Unique host identifier). This parameter specifies a unique ID for each host. The host with the lowest numerical priority among the current members of the cluster handles all of the cluster's network traffic that is not covered by a port rule.

    You can override these priorities or provide load balancing for specific ranges of ports by specifying rules on the Port rules tab of the Network Load Balancing Properties dialog box.

    In Host Parameters, you can also add dedicated IP addresses, if necessary.

  6. Click Next to continue.

  7. In Cluster IP Addresses, click Add and type the cluster IP address that is shared by every host in the cluster. NLB adds this IP address to the TCP/IP stack on the selected interface of all hosts that are chosen to be part of the cluster.

    Note

    NLB does not support Dynamic Host Configuration Protocol (DHCP). NLB disables DHCP on each interface that it configures, so the IP addresses must be static.

  8. Click Next to continue.

  9. In Cluster Parameters, select values in IP Address and Subnet mask (for IPv6 addresses, a subnet mask value is not needed). Type the full Internet name that users will use to access this NLB cluster.

  10. In Cluster operation mode, click Unicast to specify that a unicast media access control (MAC) address should be used for cluster operations. In unicast mode, the MAC address of the cluster is assigned to the network adapter of the computer, and the built-in MAC address of the network adapter is not used. We recommend that you accept the unicast default settings.

  11. Click Next to continue.

  12. In Port Rules, click Edit to modify the default port rules, if needed.

  13. To add more hosts to the cluster, right-click the new cluster, and then click Add Host to Cluster. Configure the host parameters (including host priority, dedicated IP addresses, and load weight) for the additional hosts by following the same instructions that you used to configure the initial host. Because you are adding hosts to an already configured cluster, all the cluster-wide parameters remain the same.

Additional considerations

  • For more information about host parameters, cluster IP addresses, cluster parameters, and port rules, see Network Load Balancing Manager Properties.

Additional references

Overview of Network Load Balancing

Add a Host to the Network Load Balancing Cluster

Managing Network Load Balancing Clusters

Setting Network Load Balancing Parameters

Network Load Balancing Manager Properties


Add a Host to the Network Load Balancing Cluster

Use the following procedure to add hosts to a Network Load Balancing (NLB) cluster.

When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

To ensure that Network Load Balancing Manager is displaying the most recent host information, right-click the cluster and click Refresh. This step is necessary because the host properties that Network Load Balancing Manager displays are a copy of the host properties that were configured the last time Network Load Balancing Manager connected to that host. When you click Refresh, Network Load Balancing Manager reconnects to the cluster and displays updated information.

To add a host to the NLB cluster

  1. To open Network Load Balancing Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open Network Load Balancing Manager by typing Nlbmgr at a command prompt.

  2. Right-click the cluster where you want to add the host and choose Add Host To Cluster. If NLB Manager does not list the cluster, connect to the cluster.

  3. Type the host's name and click Connect. The network adapters that are available on the host will be listed at the bottom of the dialog box.

  4. Click the network adapter that you want to use for Network Load Balancing and then click Next. The IP address configured on this network adapter will be the dedicated IP address for this host.

  5. Configure the remaining host parameters as appropriate, and then click Finish.

    For more information about setting the host parameters, see Network Load Balancing Manager Properties.

Additional considerations

  • When you create an NLB cluster, NLB is automatically bound to each of the network adapters in the cluster.

  • When you add additional hosts after the first host is added, the subsequent hosts will automatically inherit the cluster port rules from the initial host.

  • The new cluster host will not immediately be in a running state in the cluster. The new host settings must first be circulated through all cluster hosts.

Additional references

Network Load Balancing Manager Properties

Overview of Network Load Balancing

Managing Network Load Balancing Clusters

Installing Network Load Balancing


Managing Network Load Balancing Clusters

You can use Network Load Balancing (NLB) Manager to manage NLB clusters.

Connect to Existing Network Load Balancing Clusters by Using a Single Host

Connect to Existing Network Load Balancing Clusters by Using a Host List

Configure Network Load Balancing Manager Log Settings

Remove a Host from Network Load Balancing Cluster

Delete a Network Load Balancing Cluster


Connect to Existing Network Load Balancing Clusters by Using a Single Host

Use the following procedure to connect to a Network Load Balancing (NLB) cluster by typing the name of a single host. After you select a particular cluster, that cluster and all the hosts in the cluster will be displayed in NLB Manager.

When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

To connect to existing Network Load Balancing clusters by using a single host

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. Right-click Network Load Balancing Clusters, and then click Connect to Existing.

  3. Type the name of one of the cluster hosts, and then click Connect. The NLB clusters that exist on that host will be listed at the bottom of the dialog box.

  4. Click the cluster name that you want to manage from NLB Manager, and then click Finish.

Additional considerations

When using this procedure, certain network problems can prevent NLB Manager from connecting to one or more of the other hosts in the cluster. Similarly, if you have misconfigured the cluster by using duplicate priorities on multiple hosts, NLB Manager will not be able to connect to those misconfigured hosts. In these cases, some hosts will not appear in NLB Manager.

If all of the hosts do not appear in NLB Manager, try using a host list instead. See Connect to Existing Network Load Balancing Clusters by Using a Host List. In addition, information is available in the Windows event log to diagnose this issue on one or more of the cluster hosts.

Additional references

Managing Network Load Balancing Clusters

Connect to Existing Network Load Balancing Clusters by Using a Host List


Connect to Existing Network Load Balancing Clusters by Using a Host List

Use the following procedure to connect to multiple hosts and all the Network Load Balancing (NLB) clusters on those hosts. The clusters and hosts will then be displayed in NLB Manager. This is particularly useful when a host's NLB network adapter is having connectivity issues, but another network adapter is available on that host. You can also use this procedure to detect and diagnose issues such as if cluster hosts are converging separately.

The host list is a text file that you create by:

  • Typing a list in Notepad (or a similar application).

  • Exporting a previously opened list with NLB Manager.

The file should list the name of each host. Each host name should be separated by a line break. You can include comments in the host list by preceding the comment with a semicolon (;).

When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

If the NLB Manager log displays Access denied, error connecting to "host", you must reconnect to the cluster by using a logon name that is a member of the Administrators group on all hosts. You can do this by logging on with a different logon name, using Run as, or providing an alternate logon name for NLB Manager to use by clicking Credentials in the NLB Manager Options menu.

To connect to existing Network Load Balancing clusters by using a host list

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. In the File menu, click Load Host List.

  3. Navigate to and select your host list text file, and then click Open.

Additional references

Managing Network Load Balancing Clusters

Connect to Existing Network Load Balancing Clusters by Using a Single Host


Configure Network Load Balancing Manager Log Settings

Logging events in Network Load Balancing (NLB) Manager is different than logging events that are generated by the NLB driver. NLB Manager records only events that are related to the use of NLB Manager. To view events related to the NLB driver, you must use Event Viewer.

You should always manage an NLB cluster from a trusted and secure computer, particularly when event logging is enabled. The NLB Manager log file contains potentially sensitive information about the NLB cluster and hosts, so it must be properly secured. By default, the log file inherits the security settings of the directory where it is created. You might want to change the explicit permissions on the file to Restrict read and write access for individuals who do not need full control. Be aware that the individual who is using NLB Manager does require full control of the log file.

When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

To configure NLB Manager log settings

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. From the Options menu, click Log Settings.

  3. Check Enable logging and specify a name and location for the log file.

Additional references

Managing Network Load Balancing Clusters

Connect to Existing Network Load Balancing Clusters by Using a Single Host

Connect to Existing Network Load Balancing Clusters by Using a Host List


Remove a Host from Network Load Balancing Cluster

Use the following procedure to remove a single host from a Network Load Balancing (NLB) cluster. Before removing a host from the NLB cluster, you should consider using the drainstop command to disable new traffic handling and stop NLB. For more information, see Disable New Network Load Balancing Traffic Handling for Specific Ports.

When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

To remove a host or all hosts from a Network Load Balancing cluster

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. If Network Load Balancing Manager does not list the cluster, connect to the cluster.

  3. To remove a single host, right-click the host on which you want to disable Network Load Balancing, and click Delete Host.

Additional references

Delete a Network Load Balancing Cluster

Managing Network Load Balancing Clusters

Connect to Existing Network Load Balancing Clusters by Using a Single Host


Delete a Network Load Balancing Cluster

Use the following procedure to delete a Network Load Balancing (NLB) cluster.

When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

To delete a Network Load Balancing cluster

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. If Network Load Balancing Manager does not list the cluster, connect to the cluster.

  3. To delete the cluster, right-click the cluster on which you want to disable Network Load Balancing and choose Delete Cluster. All existing connections to the hosts in the cluster will be lost and the cluster will no longer exist.

Additional references

Remove a Host from Network Load Balancing Cluster

Managing Network Load Balancing Clusters

Connect to Existing Network Load Balancing Clusters by Using a Single Host


Setting Network Load Balancing Parameters

You can use Network Load Balancing (NLB) Manager to set NLB parameters.

Configure Network Load Balancing Cluster Parameters

Configure Network Load Balancing Cluster Operation Mode

Configure Network Load Balancing Host Parameters

Create a new Network Load Balancing Port Rule

Edit a Network Load Balancing Port Rule

Remove a Network Load Balancing Port Rule


Configure Network Load Balancing Cluster Parameters

Use the following procedure to configure Network Load Balancing (NLB) cluster parameters. You perform this procedure on only a single host. All hosts will automatically inherit the cluster configuration from the initial host. The parameters that you set in the Properties dialog box are recorded in the registry of each host.

When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

To ensure that Network Load Balancing Manager is displaying the most recent host information, right-click the cluster and click Refresh. This step is necessary because the host properties that Network Load Balancing Manager displays are a copy of the host properties that were configured the last time Network Load Balancing Manager connected to that host. When you click Refresh, Network Load Balancing Manager reconnects to the cluster and displays updated information.

To configure Network Load Balancing Cluster parameters

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. If NLB Manager does not list the cluster, connect to the cluster.

  3. Right-click the cluster and choose Cluster Properties.

  4. On the Cluster Parameters tab, specify values for IP address, Subnet mask, Full Internet name, and Cluster Operation Mode.
Note

Changes to NLB parameters are applied when you click OK in the Properties dialog box. Clicking OK stops NLB (if it is running), reloads the parameters, and then restarts cluster operations.

Additional references

Network Load Balancing Manager Properties

Configure Network Load Balancing Host Parameters

Create a new Network Load Balancing Port Rule


Configure Network Load Balancing Cluster Operation Mode

Use the following procedure to configure the Network Load Balancing (NLB) cluster operation mode.

When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

To configure the Network Load Balancing cluster operation mode

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. If NLB Manager does not already list the cluster, connect to the cluster.

  3. Right-click the cluster and choose Cluster Properties.

  4. On the Cluster Parameters tab, in Cluster operation mode, select Unicast or Multicast. If appropriate, you can also enable Internet Group Management Protocol (IGMP) support by selecting the IGMP multicast check box.

Additional considerations

  • The cluster operation mode parameters specify whether a multicast media access control (MAC) address should be used for cluster operations. If multicast is enabled, NLB converts the cluster MAC address for the cluster adapter into a multicast address. It also ensures that the cluster's primary IP address resolves to this multicast address as part of the Address Resolution Protocol (ARP). The adapter can now use its original, built-in MAC address that was disabled in unicast mode.

  • You must first enable multicast support before enabling Internet Group Management Protocol (IGMP) support. IGMP support can also be enabled on the network adapter.

  • The IGMP multicast check box enables IGMP support for limiting switch flooding by limiting traffic to "Network Load Balancing ports" only. That is, enabling IGMP support ensures that traffic intended for an NLB cluster passes through only those ports serving the cluster hosts and not all switch ports.

Additional references

Configure Network Load Balancing Cluster Parameters

Setting Network Load Balancing Parameters


Configure Network Load Balancing Host Parameters

Use the following procedure to configure Network Load Balancing (NLB) host parameters. The parameters set in the Properties dialog box are recorded in the registry on each host

When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

To ensure that Network Load Balancing Manager is displaying the most recent host information, right-click the cluster and click Refresh. This step is necessary because the host properties that Network Load Balancing Manager displays are a copy of the host properties that were configured the last time Network Load Balancing Manager connected to that host. When you click Refresh, Network Load Balancing Manager reconnects to the cluster and displays updated information.

To configure Network Load Balancing host parameters

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. If NLB Manager does not list the cluster, connect to the cluster.

  3. Right-click the host that you want to configure, and then click Host Properties.

  4. On the Host Parameters tab, specify values for Priority (unique host identifier), IP address, and Subnet mask, and select an initial host state.
Note

Changes to NLB parameters are applied when you click OK in the Properties dialog box. Clicking OK stops NLB (if it is running), reloads the parameters, and then restarts cluster operations.

Additional references

Network Load Balancing Manager Properties

Setting Network Load Balancing Parameters


Create a new Network Load Balancing Port Rule

Port rules control how a Network Load Balancing (NLB) cluster functions. To maximize control of various types of TCP/IP traffic, you can set up port rules to control how each port's cluster-network traffic is handled. The method by which a port's network traffic is handled is called its filtering mode. There are three possible filtering modes: Multiple hosts, Single host, and Disabled.

You can also specify that a filtering mode apply to a numerical range of ports. You do this by defining a port rule with a set of configuration parameters that define the filtering mode. Each rule consists of the following configuration parameters:

  • The virtual IP address that the rule should apply to

  • The TCP or UDP port range that this rule should apply to

  • The protocols that this rule should apply to, including TCP, UDP, or both

  • The filtering mode that specifies how the cluster handles traffic, which is described by the port range and the protocols

In addition, you can select one of three options for client affinity: None, Single, or Network. Single and Network are used to ensure that all network traffic from a particular client is directed to the same cluster host. To allow NLB to properly handle IP fragments, you should avoid using None when you select UDP or Both for your protocol setting.

Note

By default, all cluster network traffic that is not governed by port rules is handled by the host with the highest host priority among the current members of the cluster. This single host handles all of the cluster network traffic, with another host taking over the traffic if the highest priority host fails or goes offline. This default behavior ensures that NLB does not affect cluster network traffic for ports that you do not specifically manage with the NLB load-balancing mechanisms. It also provides high availability in handling your cluster network traffic.

When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

To ensure that Network Load Balancing Manager is displaying the most recent host information, right-click the cluster and click Refresh. This step is necessary because the host properties that Network Load Balancing Manager displays are a copy of the host properties that were configured the last time Network Load Balancing Manager connected to that host. When you click Refresh, Network Load Balancing Manager reconnects to the cluster and displays updated information.

To create a new Network Load Balancing port rule

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. If NLB Manager does not list the cluster, connect to the cluster.

  3. Right-click the cluster, and then click Cluster Properties.

  4. Click the Port Rules tab, and then click Add. Using information from the checklist for configuring NLB, specify values for the following:

    • Cluster IP address, which is the virtual IP address that you want this rule to apply to. Enter a specific virtual IP address to create a virtual cluster, or check All to apply the rule to all virtual IP addresses.

    • Port range

    • Protocols

    • Filtering mode

    • Affinity and Load weight (as appropriate)

  5. Click OK. This applies changes to the NLB parameters, stops NLB (if it is running), reloads the parameters, and then restarts cluster operations.

Additional considerations

  • The number and type of rules must be exactly the same for each host in the cluster. NLB Manager handles pushing the port rules across the hosts in the cluster.

  • If a host attempts to join the cluster with a different number of rules than the other hosts, it is not accepted as part of the cluster, and the rest of the cluster continues to handle the traffic as before. At the same time, a message is entered into the Windows event log. When this happens, consult the event log to determine which host has a conflicting number of rules, resolve the conflict, and restart NLB on this host.

  • The rules that are entered on each host in the cluster must have matching cluster IP addresses, port ranges, protocol types, and filtering modes.

    If NLB detects an inconsistent rule among the hosts in the cluster, it records a message in the Windows event log. Consult the event log to determine the host in question and which rule is responsible for the issue. Fix the rule and restart NLB on that host. For more information about error logging and cluster operations, see Additional references.

  • When using NLB to load balance virtual private network (VPN) traffic (such as PPTP/GRE and IPSEC/L2TP), you must configure the port rules that govern the ports handling the VPN traffic (TCP port 1723 for PPTP and UDP port 500 for IPSEC) to use either Single or Network affinity.

  • To allow NLB to properly handle IP fragments, you should avoid using the None affinity value when you select UDP or Both for your protocol setting. You should instead set affinity to Single.

  • The list of all currently installed port rules is sorted by port range.

  • The parameters that are set in the Properties dialog box are recorded in the registry on each host.

Additional references

Setting Network Load Balancing Parameters

Edit a Network Load Balancing Port Rule

Remove a Network Load Balancing Port Rule

Configure Network Load Balancing Manager Log Settings

Network Load Balancing Manager Properties


Edit a Network Load Balancing Port Rule

Use the following procedure to edit an existing Network Load Balancing (NLB) port rule.

When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

To ensure that Network Load Balancing Manager is displaying the most recent host information, right-click the cluster and click Refresh. This step is necessary because the host properties that Network Load Balancing Manager displays are a copy of the host properties that were configured the last time Network Load Balancing Manager connected to that host. When you click Refresh, Network Load Balancing Manager reconnects to the cluster and displays updated information.

To edit a Network Load Balancing port rule

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. Right-click the cluster, and then click Cluster Properties.

  3. Click the Port Rules tab.

  4. In the Defined port rules list, click a rule, and then click Edit.

  5. Modify the cluster IP address that you want this rule to apply to, the port range, protocols and filtering mode parameters as required, and then click OK.

  6. In the Properties dialog box, click OK. This applies changes to the NLB parameters, stops NLB (if it is running), reloads the parameters, and then restarts cluster operations.

Additional considerations

  • The number and type of rules must be exactly the same for each host in the cluster. This is best achieved by using NLB Manager to configure port rules. When you add additional hosts by using NLB Manager, they automatically inherit the cluster port rules from the initial host.

    If a host attempts to join the cluster with a different number of rules or with different rules from the other hosts, it is not accepted as part of the cluster. The rest of the cluster continues to handle the traffic. At the same time, a message is entered into the Windows event log. Consult the event log to determine which host is in conflict with the other cluster hosts, resolve the conflict, and then restart NLB on that host.

  • The list of all currently installed port rules is sorted by port range.

  • The parameters set in the Properties dialog box are recorded in the registry on each host.

Additional references

Setting Network Load Balancing Parameters

Create a new Network Load Balancing Port Rule

Remove a Network Load Balancing Port Rule

Configure Network Load Balancing Manager Log Settings

Network Load Balancing Manager Properties


Remove a Network Load Balancing Port Rule

Use the following procedure to remove an existing Network Load Balancing (NLB) port rule.

When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

To ensure that Network Load Balancing Manager is displaying the most recent host information, right-click the cluster and click Refresh. This step is necessary because the host properties that Network Load Balancing Manager displays are a copy of the host properties that were configured the last time Network Load Balancing Manager connected to that host. When you click Refresh, Network Load Balancing Manager reconnects to the cluster and displays updated information.

To remove a Network Load Balancing port rule

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. Right-click the cluster name, and then click Cluster Properties.

  3. Click the Port Rules tab.

  4. Click the rule you want to remove, and then click Remove.

  5. Click OK in the Properties dialog box. This applies changes to the NLB parameters, stops NLB (if it is running), reloads the parameters, and then restarts cluster operations.

Additional considerations

  • The number and type of rules must be exactly the same for each host in the cluster. This is best achieved by using NLB Manager to configure port rules. When you add additional hosts by using NLB Manager, they automatically inherit the cluster port rules from the initial host.

    If a host attempts to join the cluster with a different number of rules or with different rules from the other hosts, it is not accepted as part of the cluster. The rest of the cluster continues to handle the traffic. At the same time, a message is entered into the Windows event log. Consult the event log to determine which host is in conflict with the other cluster hosts, resolve the conflict, and then restart NLB on that host.

  • The list of all currently installed port rules is sorted by port range.

  • The parameters set in the Properties dialog box are recorded in the registry on each host.

Additional references

Setting Network Load Balancing Parameters

Create a new Network Load Balancing Port Rule

Edit a Network Load Balancing Port Rule

Configure Network Load Balancing Manager Log Settings

Network Load Balancing Manager Properties


Controlling Hosts on Network Load Balancing Clusters

The following topics provide information about controlling hosts on your Network Load Balancing (NLB) clusters.

Stop or Start Handling Network Load Balancing Cluster Traffic

Suspend or Resume Network Load Balancing

Disable or Enable All Network Load Balancing Traffic Handling for Specific Ports

Disable New Network Load Balancing Traffic Handling for Specific Ports


Stop or Start Handling Network Load Balancing Cluster Traffic

Use the following procedures to stop and start handling Network Load Balancing (NLB) cluster traffic. You might need to stop and restart NLB cluster traffic when:

  • Undertaking troubleshooting or maintenance operations.

  • Dealing with application issues on one or more hosts in the cluster.

  • Scaling down the cluster because the traffic no longer requires the current number of hosts.

Stopping or starting handling Network Load Balancing cluster traffic

  • Using the Windows interface

  • Using a Command Prompt window

To stop or start handling Network Load Balancing cluster traffic by using the Windows interface

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. If NLB Manager does not list the cluster, connect to the cluster.

  3. If you want to stop cluster operations on all cluster hosts, right-click the cluster, point to Control Hosts, and then click Stop.

    If you want to stop the cluster service on only a particular host, right-click the host, point to Control Host, and then click Stop.

  4. If you want to start cluster operations on all cluster hosts, right-click the cluster, point to Control Hosts, and then click Start.

    If you want to start the cluster service on only a particular host, right-click the host, point to Control Host, and then click Start.

Additional considerations

  • When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

  • When you stop handling NLB cluster traffic, client connections that are already in progress are interrupted. To avoid interrupting active connections, consider using the drainstop cluster-control command (instead of the stop command), which allows the host to continue servicing active connections but disables all new traffic to that host.

  • You can restart cluster operations after stopping or suspending them. When you click Start on the cluster or host that you want to restart, it restarts cluster operations, but it does not enable the use of cluster-control commands, which have been disabled by a previous suspend command.

    For more information, see Additional references.

To stop or start handling Network Load Balancing cluster traffic by using a Command Prompt window

  1. To open a Command Prompt window, click Start, right-click Command Prompt, and then click either Run as administrator or Open.

  2. Type one of the following commands:

    • To stop handling all cluster traffic on this host, type:

      nlb.exe stop
      Or, if you want to stop cluster operations on all cluster hosts, type:

      nlb.exe stop <cluster IP address | cluster name> global
    • To start handling all cluster traffic on this host, type:

      nlb.exe start
      Or, if you want to start cluster operations on all cluster hosts, type:

      nlb.exe start <cluster IP address | cluster name> global

Additional considerations

  • When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

  • When you use the stop command, client connections that are already in progress are interrupted. To avoid interrupting active connections, consider using the drainstop cluster-control command (instead of the stop command), which allows the host to continue servicing active connections but disables all new traffic to that host.

    For more information, see Additional references.

  • The stop command differs from the suspend command. The suspend command stops NLB on the host and suspends all NLB cluster-control commands on the host (except the resume and query commands). The Stop command stops NLB on the host but does not affect the other NLB cluster-control commands.

  • The start command can be used after a stop or suspend command. It restarts cluster operations, but it does not enable the use of cluster-control commands (including remote control commands), which have been disabled by a previous suspend command.

    For more information, see Additional references.

  • You should not use the start command to form a new cluster.

Additional references

Disable New Network Load Balancing Traffic Handling for Specific Ports

Suspend or Resume Network Load Balancing

Controlling Hosts on Network Load Balancing Clusters


Suspend or Resume Network Load Balancing

You might need to suspend and resume Network Load Balancing (NLB) to override any remote control commands that are issued. All subsequent cluster-control commands except resume and query are ignored. The following procedures can be performed on the whole NLB cluster or on a single host.

Suspending or resuming Network Load Balancing

  • Using the Windows interface

  • Using a Command Prompt window

To suspend or resume Network Load Balancing by using the Windows interface

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. If NLB Manager does not already list the cluster, connect to the cluster.

  3. If you want to suspend cluster operations on all cluster hosts, right-click the cluster, point to Control Hosts, and then click Suspend.

    If you want to suspend the cluster service on only a particular host, right-click the host, point to Control Host, and click Suspend.

  4. If you want to resume cluster operations on all cluster hosts, right-click the cluster, point to Control Hosts, and then click Resume.

    If you want to start the cluster service on only a particular host, right-click the host, point to Control Host, and then click Resume.

Additional considerations

  • When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

  • Suspending NLB differs from stopping the handling of NLB cluster traffic in that suspending NLB stops NLB on the host and suspends all NLB cluster-control commands on the host (except for the resume and query commands). Stopping the handling of NLB cluster traffic stops NLB on the host, but it does not affect the other NLB cluster-control commands. For more information on the stop command, see Additional references.

Additional references

Stop or Start Handling Network Load Balancing Cluster Traffic

Controlling Hosts on Network Load Balancing Clusters

To suspend or resume Network Load Balancing by using a Command Prompt window

  1. To open a Command Prompt window, click Start, right-click Command Prompt, and then click either Run as administrator or Open.

  2. Type one of the following commands:

    • To suspend NLB on this host, type:

      nlb.exe suspend
      Or, if you want to suspend cluster operations on all cluster hosts, type:

      nlb.exe suspend <cluster IP address | cluster name> global
    • To resume NLB on this host, type:

      nlb.exe resume
      Or, if you want to resume cluster operations on all cluster hosts, type:

      nlb.exe resume <cluster IP address | cluster name> global

Additional considerations

  • When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

  • The stop command differs from the suspend command. The suspend command stops NLB on the host and suspends all NLB cluster-control commands on the host (except the resume and query commands). The Stop command stops NLB on the host, but it does not affect the other NLB cluster-control commands.

Additional references

Stop or Start Handling Network Load Balancing Cluster Traffic

Controlling Hosts on Network Load Balancing Clusters


Disable or Enable All Network Load Balancing Traffic Handling for Specific Ports

The procedures below describe how to disable and immediately block all Network Load Balancing (NLB) traffic handling. When you disable all traffic handling, all ports specified by the port rule are affected. After you disable NLB traffic handling, you can enable it at any time.

Disabling or enabling all Network Load Balancing traffic handling for specific ports

  • Using the Windows interface

  • Using a Command Prompt window

To disable or enable all Network Load Balancing traffic handling for specific ports by using the Windows interface

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. If NLB Manager does not already list the cluster, connect to the cluster.

  3. Right-click a host or a cluster, and then click Control Ports.

  4. To disable specific ports, select the port rule that contains the ports that you want to disable, and then click Disable.

    To enable all traffic handling, select the port rule that contains the ports that you want to enable, and then click Enable.

Additional considerations

  • When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

  • This procedure has no effect if the specified hosts have not started cluster operations.

Additional references

Disable New Network Load Balancing Traffic Handling for Specific Ports

Suspend or Resume Network Load Balancing

Controlling Hosts on Network Load Balancing Clusters

To disable or enable all Network Load Balancing traffic handling for specific ports by using a Command Prompt window

  1. To open a Command Prompt window, click Start, right-click Command Prompt, and then either click Run as administrator or Open.

  2. Type one of the following commands:

    • To disable all traffic handling for specific ports, type:

      nlb.exe disable vip[:port|:all] | all[:port|:all] cluster[:host]| all [local|global]
    • To enable all traffic handling for specific ports, type:

      nlb.exe enable vip[:port|:all] | all[:port|:all] cluster[:host]| all [local|global]

Additional considerations

  • When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

  • This procedure has no effect if the specified hosts have not started cluster operations.

Additional references

Disable New Network Load Balancing Traffic Handling for Specific Ports

Suspend or Resume Network Load Balancing

Controlling Hosts on Network Load Balancing Clusters


Disable New Network Load Balancing Traffic Handling for Specific Ports

The procedures below describe how to disable new Network Load Balancing (NLB) traffic handling for specified ports.

Disabling new Network Load Balancing traffic handling for specific ports

  • Using the Windows interface

  • Using a Command Prompt window

To disable new Network Load Balancing traffic handling for specific ports by using the Windows interface

  1. To open NLB Manager, click Start, click Administrative Tools, and then click Network Load Balancing Manager. You can also open NLB Manager by typing Nlbmgr at a command prompt.

  2. If NLB Manager does not already list the cluster, connect to the cluster.

  3. Right-click a host or a cluster, and then click Control Ports.

  4. To disable new traffic handling, click Drain.

    To disable new traffic handling and stop Network Load Balancing, click Drainstop.

Additional considerations

  • When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

  • This procedure has no effect if the specified hosts have not started cluster operations.

  • Drain disables new traffic handling for the rule that contains the specified port in the port range. New connections to the specified hosts are not allowed but all active connections are maintained. To disable active connections, use the Disable command instead.

  • Performing the drain command at the cluster level drains the specified ports on all hosts within the cluster. Performing the drain command at the host level drains the ports on the specific host only.

Additional references

Disable or Enable All Network Load Balancing Traffic Handling for Specific Ports

Suspend or Resume Network Load Balancing

Controlling Hosts on Network Load Balancing Clusters

To disable new Network Load Balancing traffic handling for specific ports by using a Command Prompt window

  1. To open a Command Prompt window, click Start, right-click Command Prompt, and then click Open.

  2. Type one of the following commands:

    • To disable traffic handling for specific ports, type:

      nlb.exe drain vip[:port|:all] | all[:port|:all] cluster[:host]| all [local|global]
    • To disable new traffic handling and stop Network Load Balancing, type:

      nlb.exe drainstop

Additional considerations

  • When you are using Network Load Balancing (NLB) Manager, you must be a member of the Administrators group on the host that you are configuring, or you must have been delegated the appropriate authority. If you are configuring a cluster or host by running NLB Manager from a computer that is not part of the cluster, you do not have to be a member of the Administrators group on that computer.

  • This command has no effect if the specified hosts have not started cluster operations.

  • Drain disables new traffic handling for the rule that contains the specified port in the port range. New connections to the specified hosts are not allowed, but all active connections are maintained. To disable active connections, use the Disable command instead.

  • Performing the drain command at the cluster level drains the specified ports on all hosts within the cluster. Performing the drain command at the host level drains the ports on the specific host only.

Additional references

Disable or Enable All Network Load Balancing Traffic Handling for Specific Ports

Suspend or Resume Network Load Balancing

Controlling Hosts on Network Load Balancing Clusters


Removing Network Load Balancing

In Windows Server 2008, you can remove installed features from your server by using the Remove Features Wizard.

Use the following procedure to remove Network Load Balancing (NLB).

To remove NLB

  • In the Features Summary area of the Server Manager main window, click Remove Features, and then click Network Load Balancing.

    —or—

  • In the Customize this server area of the Initial Configuration Tasks window, click Remove Features, and then click Network Load Balancing.

    —or—

  • You can remove NLB by typing the following command:

    servermanagercmd.exe -remove nlb
Note

The Initial Configuration Tasks window opens by default when a member of the Administrators group logs on to the computer. Server Manager opens when the Initial Configuration Tasks window is closed. You can also open Server Manager by using shortcuts on the Start menu or in Administrative Tools.

Additional references

Installing Network Load Balancing

Overview of Network Load Balancing


Troubleshooting Network Load Balancing Clusters

This section lists some common issues that you might encounter when using Network Load Balancing (NLB) clusters.

What problem are you having?

  • After installing Network Load Balancing and restarting a cluster host, a message appears: "The system has detected an IP address conflict with another system on the network..."

  • There is no response when you use ping to access the cluster's IP address from an outside network.

  • There is no response when you use ping to access a host's dedicated IP addresses from another cluster host.

  • When attempting to use Network Load Balancing Manager to connect to a host in your cluster, you receive the error "Host unreachable."

  • When using Telnet or attempting to browse a computer outside the cluster from a cluster host, there is no response.

  • When invoking the Network Load Balancing remote control commands from a computer outside the cluster, there is no response from one or more cluster hosts.

  • There is no reply when you use the dedicated IP address of a host to specify it as a target for a remote control command. However, specifying the host by its priority (ID) works.

  • Connectivity to the cluster is denied to some users, but not all.

  • You cannot view or change the Network Load Balancing properties by using net config and Windows Management Instrumentation (WMI).

  • An unusual number of TCP connections to the cluster's IP address are being reset by the server or the client.

  • Virtual Private Network (VPN) calls fail when you make a change that causes convergence (such as adding a host, removing a host, or draining a host).

  • After the cluster hosts start, they begin converging, but they never complete convergence.

  • The cluster moves in and out of a converged state.

  • After the cluster hosts start, Network Load Balancing reports that convergence has finished, but more than one host is a default host.

  • Network Load Balancing is not load balancing applications, and the default host handles all network traffic.

  • Traffic alternates unexpectedly between the cluster hosts, and it breaks TCP connections.

  • Network traffic does not appear to load balance evenly among the cluster hosts.

  • When you are using Network Load Balancing with Microsoft Internet Security and Acceleration (ISA) Server, one cluster host logs blocked packets that are directed to the dedicated Internet Protocol (IP) address of another host.

  • You are unable to create a Network Load Balancing cluster in a 64-bit version environment.

After installing Network Load Balancing and restarting a cluster host, a message appears: "The system has detected an IP address conflict with another system on the network..."
  • Cause: The same IP address already exists on the network.

  • Solution: Choose a new IP address, or remove the duplicate address.

  • Cause: You have configured different cluster operation modes (Unicast or Multicast) on the hosts, which causes two different MAC addresses to map to the same IP address.

  • Solution: Ensure that all hosts are configured with the same cluster operation mode.

  • Cause: You configured the cluster's IP address before NLB was bound to the network adapter.

  • Solution: Remove the cluster's IP address from TCP/IP properties, enable NLB on the proper adapter, and then configure the cluster's IP address.

  • Cause: You added the cluster's IP address to a network adapter that has not been enabled for NLB.

  • Solution: Remove the cluster's IP address from the incorrect adapter's TCP/IP properties, enable NLB on the proper adapter, and then configure the cluster's IP address.

For more information about enabling NLB, see Installing Network Load Balancing

There is no response when you use ping to access the cluster's IP address from an outside network.

Verify that you can use ping to access the dedicated IP addresses for the cluster hosts from a computer outside the router. If this test fails, and you are using multiple network adapters, the issue is not related to NLB. If you are using a single network adapter for the dedicated and cluster IP addresses, consider the following causes:

  • Cause: If you are using multicast support, you might find that your router has difficulty resolving the primary IP address into a multicast media access control (MAC) address by using the Address Resolution Protocol (ARP).

  • Solution: Verify that you can use ping to access the cluster from a client on the cluster's subnet and to access the cluster hosts' dedicated IP addresses from a computer outside the router. If these tests work properly, the router is probably at fault. You should be able to add a static ARP entry to the router to circumvent the issue. You can also turn off NLB multicast support and use a unicast network address without a hub.

  • Cause: When using NLB in multicast or unicast mode, routers need to accept proxy ARP responses (IP-to-network address mappings that are received with a different network source address in the Ethernet frame).

  • Solution: Make sure that your router has proxy ARP support turned on. You can also set a static ARP entry to keep proxy ARP support disabled in the router.

  • Cause: Internet control message protocol (ICMP) to the cluster is blocked by a router or firewall.

  • Solution: Allow ICMP traffic through the router or firewall. Be aware that this may expose your system to additional security risk.

There is no response when using ping to access a host's dedicated IP addresses from another cluster host.
  • Cause: When using NLB in multicast or unicast mode, routers need to accept proxy ARP responses (IP-to-network address mappings that are received with a different network source address in the Ethernet frame).

  • Solution: Make sure that your router has proxy ARP support turned on. You can also set a static ARP entry to keep proxy ARP support disabled in the router.

  • Cause: Internet control message protocol (ICMP) to the cluster is blocked by a router or firewall.

  • Solution: Allow ICMP traffic through the firewall or router. Be aware that this may expose your system to additional security risk.

When attempting to use Network Load Balancing Manager to connect to a host in your cluster, you receive the error "Host unreachable."
  • Cause: Internet control message protocol (ICMP) to the host is either blocked by a router or firewall or disabled on the host's network adapter.

  • Solution: Enable ICMP on the host's network adapter or allow ICMP traffic through the firewall or router. Be aware that this may expose your system to additional security risk. You can also use NLB Manager's /noping option.

When using Telnet or attempting to browse a computer outside the cluster from a cluster host, there is no response.
  • Cause: Verify that you can use ping to access the computer outside the cluster. If this test is successful, you might not have listed the host's dedicated IP address first in the TCP/IP properties.

  • Solution: If ping fails to access the computer outside of the cluster, refer to the following issues (described earlier in this Troubleshooting topic):

    • There is no response when using ping to access the cluster's IP address from an outside network.

    • There is no response when using ping to access a host's dedicated IP addresses from another cluster host.

When invoking the Network Load Balancing remote control commands from a computer outside the cluster, there is no response from one or more cluster hosts.
  • Cause: Remote control commands are not being sent to the cluster's IP address.

  • Solution: Commands must be sent to the cluster's primary IP address, which was assigned in the Network Load Balancing Properties dialog box. Be sure that you send remote commands to the correct IP address.

  • Cause: The remote control traffic is being encrypted by Internet Protocol security (IPSec). NLB remote control commands will not work correctly if they are sent from a computer that has IPSec configured so that the remote control traffic is encrypted by IPSec.

  • Solution: Disable IPSec.

    For more information, see the Internet Protocol Security (IPSec) Help content.

  • Cause: NLB UDP control ports are protected incorrectly by a firewall. By default, remote control commands are sent to UDP ports 1717 and 2504 at the cluster IP address.

  • Solution: Be sure that these ports have not been blocked incorrectly by a router or firewall. You can also change the port number by modifying the corresponding NLB parameter.

There is no reply when you use the dedicated IP address of a host to specify it as a target for a remote control command. However, specifying the host by its priority (ID) works.
  • Cause: None of the hosts have a dedicated IP address.

  • Solution: Assign a dedicated IP address to each host. For more information, see Configure Network Load Balancing Host Parameters.

Connectivity to the cluster is denied to some users, but not all.
  • Cause: An application that is being load balanced is not responding.

  • Solution: This is an application-specific issue that is not related to NLB. Refer to your application's documentation to correct this issue. You may need to stop and restart the application.

  • Cause: If your cluster is configured for unicast mode, a switch might have learned the NLB network adapter's MAC address.

  • Solution: Clear the switch's port to MAC address mapping.

  • Cause: The cluster's IP address was not added to TCP/IP on one or more of the hosts.

  • Solution: If you do not use NLB Manager to configure your cluster, you must manually configure TCP/IP with the cluster's IP address.

  • Cause: A host is leaving the cluster because of a drainstop or stop command, but convergence did not complete correctly.

  • Solution: Wait for the convergence to complete. If the convergence does not complete, see the following issue later in this Troubleshooting topic:

    After the cluster hosts start, they begin converging, but they never complete convergence

You cannot view or change the Network Load Balancing properties by using net config and Windows Management Instrumentation (WMI).
  • Cause: To view or change Network Load Balancing properties, you must be a member of the Administrators group.

  • Solution: Log on as a user who is in the local Administrators group of the computer that is running NLB.

An unusual number of TCP connections to the cluster's IP address are being reset by the server or the client.
  • Cause: The HTTP keep-alive values are enabled on the NLB hosts and keep-alive value-enabled clients are connecting to the cluster.

  • Solution: Disable HTTP keep-alive values. For more information about HTTP keep-alive values and Internet Information Services (IIS), refer to the IIS documentation set.

    To view the IIS documentation set from your desktop, install IIS, then click Start, click Run, and type the following command in the Open text box:

    %windir%\help\iisrv.chm

  • Cause: Low system resources on the server are causing TCP to reject the connections.

  • Solution: Free system resources by, for example, adding additional system memory or closing unnecessary applications.

  • Cause: The cluster has diverged into two separately converged clusters, which causes more than one node to claim ownership of every connection.

  • Solution: Remove the two clusters, then recreate a single cluster.

Virtual Private Network (VPN) calls fail when you make a change that causes convergence (such as adding a host, removing a host, or draining a host).
  • Cause: When using NLB to load balance VPN traffic, you must configure the port rules that govern the ports handling the VPN traffic (TCP port 1723 for PPTP/GRE and UDP port 500 for IPSEC/L2TP) to use either Single or Network affinity.

  • Solution: Configure the port rules that govern ports 500 and 1723 to use Single or Network affinity. For more information, see Network Load Balancing Manager Properties.

After the cluster hosts start, they begin converging, but they never complete convergence.
  • Cause: A different number of port rules or incompatible port rules on different cluster hosts were entered. This will inhibit convergence.

  • Solution: Open the Network Load Balancing Properties dialog box on each cluster host and verify that all hosts have identical port rules.

  • Cause: You have a bad network adapter or cable.

  • Solution: Use the ping command to test connectivity. Enter the host's fully qualified domain name. You can also learn more about the issue by using the ping command to search your domain controller by IP address and other network servers by name and IP address.

  • Cause: Duplex settings on a switch or hub are mismatched.

  • Solution: Confirm that the duplex settings in each of your switches and hubs are configured appropriately.

  • Cause: The dedicated IP address that you used for one of the hosts already exists on the network.

  • Solution: Choose a new IP address, or remove the duplicate address.

  • Cause: Your cluster contains hosts that are running Windows 2000.

  • Solution: Your cluster must be running Windows Server 2008 on all hosts. An NLB cluster environment that contains hosts with Windows Server 2003 and Windows Server 2008 is supported only when performing a rolling upgrade to Windows Server 2008. Mixing Windows Server 2003 and Windows Server 2008 in the same cluster is not supported for long periods of time.

  • Cause: You have configured different cluster operation modes (unicast and multicast) on the hosts.

  • Solution: Use NLB Manager to ensure that all hosts are configured with the same cluster operation mode.

Note

You can also view the Windows event logs to check for errors and warnings. For more information see Installing Network Load Balancing.

The cluster moves in and out of a converged state.
  • Cause: Heartbeats are being missed due to intermittent network connectivity caused by a bad network adapter or cable or other network problems.

  • Solution: Use the ping command to test connectivity. Enter the host's fully qualified domain name. You can also learn more about the issue by using the ping command to search your domain controller by IP address and other network servers by name and IP address.

After the cluster hosts start, Network Load Balancing reports that convergence has finished, but more than one host is a default host.
  • Cause: The cluster hosts have become members of different subnets, so all the hosts are not accessible on the same network.

  • Solution: Be sure that all cluster hosts can communicate with each other.

  • Cause: A layer-three switch is being used.

  • Solution: Put a layer-two switch between the hosts and the layer-three switch.

  • Cause: A break in a redundant switch caused the cluster to separate into two clusters, creating two default hosts.

  • Solution: Remove the two clusters, then create a single cluster.

  • Cause: Your switch is configured to reject broadcast packets.

  • Solution: Configure your switch to accept broadcast packets (be aware that this might introduce certain security risks), or configure your NLB cluster to use multicast mode.

  • Cause: One host is unable to send or receive heartbeats.

  • Solution: Use the ping command to test connectivity to each of the hosts. Enter the hosts' fully-qualified domain name.

  • Cause: A host is plugged into the wrong port on the switch.

  • Solution: Use the correct port on the switch.

Network Load Balancing is not load balancing applications, and the default host handles all the network traffic.
  • Cause: A port rule is missing. By default, NLB directs all incoming network traffic that is not governed by port rules to the default host—this ensures that applications that you do not want load balanced behave properly.

  • Solution: To load balance an application across the cluster, create a port rule on every cluster host for the TCP/IP ports that are serviced by the application.

  • Cause: You added a second host to a single host cluster, but the second host is not configured correctly. The cluster never converges and the original host continues to handle all of the traffic.

  • Solution: Carefully review (and if necessary, correct) each of the settings on the second host—for example, the cluster IP address, dedicated IP address, and port rules.

  • Cause: If your cluster is configured for unicast mode, a switch might have learned the NLB network adapter's MAC address.

  • Solution: Clear the switch's port to MAC address mapping.

  • Cause: A proxy server is sending all connections that are using a single IP address to your cluster in single affinity mode.

  • Solution: Configure your proxy server to use multiple IP addresses.

Traffic alternates unexpectedly between the cluster hosts, and it breaks TCP connections.
  • Cause: Unicast network addresses are causing issues with the switching hub. If you are using a switching hub to interconnect the cluster hosts, you must use NLB multicast support. Otherwise, the switch can behave erratically when the same unicast network is used on multiple switch ports.

  • Solution: Check that you have selected multicast support in the Network Load Balancing Properties dialog box. If you do not want to use multicast support, you can interconnect the cluster hosts with a hub or coaxial cable instead of with a switch.

Network traffic does not appear to load balance evenly among the cluster hosts.
  • Cause: The network traffic is coming from a limited number of IP addresses, possibly due to the setting on a proxy server.

  • Solution: Configure your proxy server to use multiple IP addresses.

When you are using Network Load Balancing with Microsoft Internet Security and Acceleration (ISA) Server, one cluster host logs blocked packets that are directed to the dedicated Internet Protocol (IP) address of another host.
  • Cause: One of the cluster hosts is configured with a host priority identifier equal to 1.

  • Solution: Do not configure any cluster host with a host priority identifier of 1. Use numbers that are greater than 1. For more information, see Configure Network Load Balancing Host Parameters.

You are unable to create a Network Load Balancing cluster in a 64-bit version environment.
  • Cause: You might not be running the appropriate NLB version for your environment. NLB cannot form a cluster when the 32-bit version of NLB is used on a 64-bit version computer. This issue might have gone undetected because 32-bit NLB components (nlb.exe, wlbs.exe, and nlbmgr.exe) appear to run correctly in the 64-bit version environment.

  • Solution: If you plan to use a 64-bit version computer environment, you must use the 64-bit NLB version.

Notes
  • The following topics describe several common issues that you might encounter when installing and initially using NLB. The topics describe the likely reasons for each issue and one or more suggested remedies. These topics assume that your system and applications meet the minimum requirements for NLB. For more information, see: Overview of Network Load Balancing and Installing Network Load Balancing.
  • You should test your network and all network adapters for proper operation before installing NLB. Be sure to follow all installation steps, and check that the cluster parameters and port rules are identically set for all cluster hosts. If an issue occurs, always check the Windows event log for a message from the NLB driver. For more information, see the sections titled Cluster parameters, Host parameters, and Port rules in Network Load Balancing Manager Properties.


Resources for Network Load Balancing

For more information about Network Load Balancing (NLB), see the following resources on the Microsoft Web site:

  • For deployment information for NLB, see http://go.microsoft.com/fwlink/?LinkId=87253.

  • For operations information for NLB, see http://go.microsoft.com/fwlink/?LinkId=87254.

  • For instructions on how to configure NLB with Terminal Services, see http://go.microsoft.com/fwlink/?LinkId=80406.

  • For troubleshooting information for NLB, see http://go.microsoft.com/fwlink/?LinkId=87255.

  • For Windows Server 2003 design information for NLB, see http://go.microsoft.com/fwlink/?LinkId=87250.

  • For Windows Server 2003 technical reference information for NLB, see http://go.microsoft.com/fwlink/?LinkId=87249.

  • For Windows Server 2003 deployment information for NLB, see http://go.microsoft.com/fwlink/?LinkId=87251.


User Interface: Network Load Balancing Manager

This section describes the Network Load Balancing Manager Properties.

Network Load Balancing Manager Properties


Network Load Balancing Manager Properties

The following table describes the properties that are related to Network Load Balancing (NLB).

Network Load Balancing properties

Tab Description

Cluster IP addresses

The IP address parameter specifies the cluster's primary IP address. IPv4 addresses use the standard Internet dotted notation (for example, w.x.y.z). IPv6 addresses use 16-byte addresses, typically expressed in colon-hexadecimal notation. Colon-hexadecimal notation uses eight 4-digit hexadecimal numbers, with colons separating the 16-bit blocks (the 4-digit numbers).

To manage addresses more easily, IPv6 suppresses leading zeros and compresses a single contiguous all-zero 16-bit block, represent the contiguous block with two colons (::). This is known as double-colon compression. An example of an IPv6 address with leading zeros suppressed is:

FEC0:0:0:0:2AA:FF:FE3F:2A1C

The address is a virtual IP address, and it must be set identically for all hosts in the cluster. This IP address is used to address the cluster as a whole, and it should be the IP address that maps to the full Internet name that you specify for the cluster.

If you want to add multiple IP addresses to the cluster, click Add to enter the additional IP addresses. If you are configuring a virtual private network (VPN) load-balancing cluster, you should not configure the dedicated IP address. On a VPN, only the cluster IP address should be present on each of the cluster hosts.

Cluster parameters
  • The IP address parameter specifies the cluster's primary IP address in standard Internet dotted notation (for example, w.x.y.z). You can select a different IP address for the cluster by clicking the drop-down list.

  • The Subnet mask parameter denotes the subnet mask for the IP address that is specified. The mask is entered in standard Internet dotted notation (for example, 255.255.255.0). This is shown only when the cluster IP address is an IPv4 address.

  • The Full Internet name parameter specifies a full Internet name for the NLB cluster (for example, cluster.microsoft.com). This name is used for the cluster as a whole, and it should be the same for all hosts in the cluster. If you alias several names for the cluster, enter the primary (main) name here. This name should be resolvable to the cluster's primary IP address through your DNS server or Hosts file.

  • The Network address parameter specifies the media access control (MAC) address for the network adapter that is to be used for handling client-to-cluster traffic. If multicast support is disabled, the host reverts to unicast mode. NLB automatically instructs the driver that belongs to the cluster adapter to override the adapter's unique, built-in network address and to change its MAC address to the cluster's MAC address. This is the address used on all cluster hosts. You do not need to manually configure the network adapter to recognize this address.

    If you have other NLB clusters on one local subnet, each cluster needs to use a different network address. When you select a different primary IP address for each cluster, NLB automatically ensures that the clusters use unique network addresses. Some network adapters might not allow the built-in network address to be modified. If you experience this issue, you must obtain and install a different network adapter that supports this functionality.

  • The Cluster operation mode parameters specify whether a multicast MAC address should be used for cluster operations. If multicast is enabled, NLB converts the cluster MAC address that belongs to the cluster adapter into a multicast address. It also ensures that the cluster's primary IP address resolves to this multicast address as part of the ARP protocol. The adapter can now use its original, built-in MAC address that was disabled in unicast mode.

    In multicast mode, you can also enable Internet Group Management Protocol (IGMP) support, which limits switch flooding by limiting traffic to Network Load Balancing ports only. That is, enabling IGMP support ensures that traffic intended for an NLB cluster passes through only those ports that are serving the cluster hosts and not all switch ports.

    If you select unicast support, NLB automatically instructs the driver that belongs to the cluster adapter to override the adapter's unique, built-in network address and to change its MAC address to the cluster's MAC address. This is the address used on all cluster hosts. You do not need to manually configure the network adapter to recognize this address. (Note that some network adapters do not support changing their MAC addresses. If you experience this issue, you must install a network adapter that does.)

Important

NLB does not support a mixed environment of unicast and multicast within a single cluster. Within each cluster, all network adapters in that cluster must be either multicast or unicast. Otherwise, the cluster will not function properly. There is no restriction on the number of network adapters, and different hosts can have a different number of adapters.

Port rules

The Port Rules tab shows only the summary of existing port rules. If you click Add or Edit, the following parameters will be available:

  • The Cluster IP address parameter specifies the cluster IP address that the port rule should cover. If this parameter is left blank and All is selected, the port rule is a global port rule, and it will cover all cluster IP addresses associated with that particular NLB cluster. If a cluster IP address is specified, the port rule overrides any conflicting global port rule for that particular cluster IP address.

  • The Port range parameter specifies the TCP/UDP port range that a port rule should cover. The default port range is 0 to 65,535. Rules for a single port are encoded as a range having the same starting and ending port numbers.

  • The Protocols parameter lets you choose the specific TCP/IP protocol that a port rule should cover: TCP, UDP, or both. Only the network traffic for the specified protocol is affected by the rule. Traffic that is not affected by the port rule is handled by the default host.

  • For Filtering mode, configure the following parameters:

    • The Multiple hosts parameter specifies that multiple hosts in the cluster will handle network traffic for the associated port rule. This filtering mode provides scaled performance and fault tolerance by distributing the network load among multiple hosts. You can specify that the load be equally distributed among the hosts or that each host will handle a specified load weight.

    • The Single host parameter specifies that network traffic for the associated port rule be handled by a single host in the cluster according to the specified handling priority. This filtering mode provides port specific fault tolerance for handling network traffic.

    • The Disable this port range parameter specifies that all network traffic for the associated port rule be blocked. In this case, the NLB driver filters all corresponding network packets or datagrams. This filtering mode lets you block network traffic that is addressed to a specific range of ports.

  • The Affinity parameter is applicable only for the Multiple hosts filtering mode.

    • The None option specifies that multiple connections from the same client IP address can be handled by different cluster hosts (there is no client affinity). To allow Network Load Balancing to properly handle IP fragments, you should avoid using None when selecting UDP or Both for your protocol setting.

    • The Single option specifies that NLB should direct multiple requests from the same client IP address to the same cluster host. This is the default setting for affinity. You can optionally modify the NLB client affinity to direct all client requests from a TCP/IP Class C address range (instead of a single IP address) to a single cluster host by enabling the Network option instead of the Single option. This feature ensures that clients that use multiple proxy servers to access the cluster can have their TCP connections directed to the same cluster host.

    • The Network option specifies that NLB direct multiple requests from the same TCP/IP Class C address range to the same cluster host. Enabling Network affinity instead of Single affinity ensures that clients that use multiple proxy servers to access the cluster have their TCP connections directed to the same cluster host.

      The use of multiple proxy servers at the client's site causes requests from a single client to appear to originate from different computers. Assuming that all of the client's proxy servers are located within the same address range, Network affinity ensures that client sessions are properly handled. If you do not need this capability, use Single affinity to maximize scaled performance.

    Enabling Single or Network affinity ensures that only one cluster host handles all connections that are part of the same client session. This is important if the server application that is running on the cluster host maintains a session state (such as server cookies) between connections.

    This does not preserve a session state with back-end databases where many different transactions are occurring that involve many different computers. When the connection ends, the session state also ends.

    Disabling affinity allows for improved load balancing because it allows multiple connections from the same client to be handled concurrently by different cluster hosts. To maximize scaled performance, disable the client affinity (by using the None option) when it is not needed. However, to allow NLB to properly handle IP fragments, you should avoid using None when selecting UDP or Both for your protocol setting.

Important

When using NLB to load balance VPN traffic, you must configure the port rules that govern the ports handling the VPN traffic (TCP port 1723 for PPTP/GRE and UDP port 500 for IPSEC/L2TP) to use either Single or Network affinity.

  • The Load weight parameter is applicable only for the Multiple hosts filtering mode. You can configure this parameter only when you open the port rules dialog box through Host Properties. (This parameter is not configurable when you open the port rules dialog box through Cluster Properties.)

    When using the Multiple hosts filtering mode, this parameter specifies the relative amount of load-balanced network traffic that this host should handle for the associated port rule. Allowed values range from 0 (zero) to 100. To prevent a host from handling any network traffic, set the load weight to 0 (zero). The actual fraction of traffic handled by each host is computed as the local load weight divided by the sum of all load weights across the cluster.

    You can specify different load weights for each host in the cluster by using the Load weight parameter. You can specify that all hosts distribute the network load equally by using the Equal load distribution parameter instead of the Load weight parameter.

  • The Handling priority parameter is applicable only for Single host filtering mode. You can configure this parameter only when you open the port rules dialog box through Host Properties. (This parameter is not available when you open the port rules dialog box through Cluster Properties.)

    When Single host filtering mode is used, the Handling priority parameter specifies the local host's priority for handling the network traffic for the associated port rule. The host with the highest handling priority (lowest numerical value) for this rule among the current members of the cluster will handle all of the traffic for this rule. The allowed values range from 1, the highest priority, to the maximum number of hosts allowed (32). This value must be unique for all hosts in the cluster. Although this parameter is displayed in the Defined port rules list, you configure this parameter on the Host Parameters tab.

Host parameters
  • The Priority (Unique host ID) parameter specifies a unique ID for each host. The host with the lowest numerical priority among the current members of the cluster handles all of the cluster's network traffic that is not covered by a port rule. You can override these priorities or provide load balancing for specific ranges of ports by specifying rules in the Port rules tab.

    If a new host joins the cluster and its priority conflicts with another host in the cluster, the host is not accepted as part of the cluster. The rest of the cluster will continue to handle the traffic. A message describing the issue is written to the Windows event log.

  • The IP address parameter specifies this host's unique IP address, which is used for network traffic that is not associated with the cluster (for example, specifying Telnet access to a specific host within the cluster). It should be entered in standard Internet dotted notation (for example, w.x.y.z). This IP address is used to individually address each host in the cluster, and it should be unique for each host. The dedicated IP address should always be entered first in TCP/IP properties.

    NLB references the dedicated IP address only when a single network adapter is used to handle both client-to-cluster traffic and other network traffic that must go specifically to the dedicated IP address. NLB ensures that all traffic to the dedicated IP address is unaffected by the NLB current configuration. This includes when this host is running as part of the cluster and when NLB is disabled due to parameter errors in the registry.

Important

Typically, both the dedicated IP address and the cluster IP address must also be entered in the Internet Protocol (TCP/IP) Properties dialog box. Make sure that the addresses are the same in both places. However, if you are configuring a virtual private network (VPN) load-balancing cluster, you should not configure the dedicated IP address. On a VPN, only the cluster IP address should be present on each of the cluster hosts. The dedicated IP address must be a static IP address—it cannot be a DHCP address.

  • The Subnet mask parameter denotes the subnet mask for the IP address specified. The mask is entered in standard Internet dotted notation (for example, 255.255.255.0).

  • The Initial host state parameter specifies whether NLB will start and whether the host will immediately join the cluster when the operating system is started. For example, you might want to start other services manually and in a specific order before starting NLB. Hosts can be commanded to join and leave the cluster dynamically by using the Start and Stop commands in NLB command-line control. If the Retain suspended state after computer starts check box is selected, when the host is shut down while in a suspended state, the host will remain suspended when Windows is started.

Additional references

Overview of Network Load Balancing

Installing Network Load Balancing

Creating Network Load Balancing Clusters

Managing Network Load Balancing Clusters